﻿using Infragistics.Win;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGrid_ValueList
{
    public partial class Form1 : Form
    {

        ValueList smallList;
        ValueList largeList;

        public Form1()
        {
            InitializeComponent();

            ultraGrid1.DataSource = getTable();


            smallList = new ValueList();
            smallList.ValueListItems.Add("1", "Item 1");
            smallList.ValueListItems.Add("3", "Item 3");
            smallList.ValueListItems.Add("5", "Item 5");

            largeList = new ValueList();
            largeList.ValueListItems.Add("0", "Item 0");
            largeList.ValueListItems.Add("1", "Item 1");
            largeList.ValueListItems.Add("2", "Item 2");
            largeList.ValueListItems.Add("3", "Item 3");
            largeList.ValueListItems.Add("4", "Item 4");
            largeList.ValueListItems.Add("5", "Item 5");


            ultraGrid1.DisplayLayout.Bands[0].Columns[1].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
            ultraGrid1.DisplayLayout.Bands[0].Columns[1].ValueList = largeList;
        }

        private DataTable getTable()
        {
            DataTable table = new DataTable();

            table.Columns.Add("col1", typeof(Int32));
            table.Columns.Add("col2", typeof(string));

            for (int i = 0; i < 5; i++)
            {
                table.Rows.Add(new object[] { i, i % 5});
            }
            return table;
        }

        private void ultraGrid1_BeforeCellListDropDown(object sender, Infragistics.Win.UltraWinGrid.CancelableCellEventArgs e)
        {
            e.Cell.ValueList = smallList;

            bool inList = false;
            foreach(ValueListItem item in smallList.ValueListItems)
            {
                if(item.DataValue.ToString() == e.Cell.Value.ToString())
                {
                    inList = true;
                    break;
                }
            }
            if (!inList)
            {
                e.Cell.Appearance.ForeColor = Color.White;
            }
        }

        private void ultraGrid1_AfterCellListCloseUp(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            e.Cell.ValueList = largeList;
            e.Cell.Appearance.ForeColor = Color.Black;
        }
    }
}
